<?php

/**
 * @author Florian Hochriegl, Florian@Hochriegl.de
 * @website www.gamers-congress.de
 * @version 2011040801
 * Überprüfen der konto-Datenbank mit den offenen REchnungen auf übereinstimmungen mit ID und Betrag
 */

// Notwendige Inputs
include("../global.php");
include("paymentConstants.php");
include("paymentFunctions.php");


if ($ADMIN->check(IS_ADMIN))
    $debug = true;
else
    $debug = false;

$auslastung = eventAuslastung();
if ( $auslastung['frei'] > 0 ){


$kontoeintraege = $DB->query_All("select * from gc_payment_konto where processed = 0");

$offeneRechnungen = $DB->query_all("select * from gc_payment where paid = 0");


if (is_array($offeneRechnungen) && is_array($kontoeintraege))
    foreach ($kontoeintraege as $kontoeintrag) {

        $output .= "Prüfe Kontoeintrag: " . $kontoeintrag['betreff'] . "<br>";
        $rechnungsNummer = -1;
        // Versuche Betreff zu finden
        if ($kontoeintrag['betreff'] != "") {
            $betreff = split("\|", $kontoeintrag['betreff']);

            foreach ($betreff as $betr) {

                $betr = strtolower($betr);

                if (stripos($betr, "rechnungsnummer") !== false || stripos($betr, "rechnung") !== false ) {
                    $betr = str_replace("rechnungsnummer", "", $betr);
                    $betr = str_replace("rechnung", "", $betr);
                    
                    $betr = str_replace(":", "", $betr);
                    $betr = trim($betr);

                    if (is_numeric($betr))
                        $rechnungsNummer = $betr;

                    if ($rechnungsNummer != -1)
                        $output .= "--> Rechnungsnummer gefunden: " . $rechnungsNummer . "<br>";
                }
            }
        }

        if ($rechnungsNummer != -1)
            foreach ($offeneRechnungen as $offeneRechnung) {
                if ($offeneRechnung['ID'] == $rechnungsNummer && $offeneRechnung['amount'] == $kontoeintrag['value']) {

                    $output .= "--> Übereinstimmende offene Rechnunge gefunden, Rechnungsnummer: " . $rechnungsNummer . "<br>";

                    $query = "UPDATE gc_payment_konto
                    SET `processed` = '1'
                    WHERE   uuid = '" . $kontoeintrag['uuid'] . "';";

                    $output .= $query."<br>";

                    $DB->query( $query );

                    activateByID($rechnungsNummer , "KontoChecker");
                }
                else
                    $output .= "--> Keine übereinstimmende offene Rechnunge gefunden<br>";
            }
    }
    else
        $output .= "Keine offenen Zahlungen und offene Rechnungen vorhanden";
}
else
    $output .= "Keine freien Plätze verfügbar - keine automatische Freischaltung mehr!";


//$HTML = new htmlout;

if ($debug)
    $myOutput = html::message("GC Payment - Kontocheck", $output);
else
    $myOutput = html::message("GC Payment - Kontocheck", "leider nicht für dich....");


$DB->query( "UPDATE events
set `kontocheck` = NOW()
where id = $GCeventID" );

$PAGE->render($myOutput);
?>
